import unittest
from unittest.mock import patch

from tmc import points
from tmc.utils import load_module, reload_module, get_stdout

exercise = 'src.what_to_wear_tomorrow'

jeans_tshirt = "Bär jeans och en T-tröja"
jumper = "Jag rekommenderar även en tröja"
jacket = "Ta med en jacka"
warm_coat = "Gör det till en varm rock, faktiskt"
gloves = "Jag tror att handskar är på sin plats"
umbrella = "Glöm inte paraplyet!"

@points('1.what_to_wear_tomorrow')
class WhatToWearTomorrowTest(unittest.TestCase):
    @classmethod 
    def setUpClass(cls):
        with patch('builtins.input', return_value = '0'):
            cls.module = load_module(exercise, 'en')

    def test_25(self):
        with patch('builtins.input', side_effect = [ '25', 'nej', AssertionError("Inmatning frågas för många gånger.") ]) as prompt:
            reload_module(self.module)
            output = get_stdout()
            input = "25, nej"
            self.assertFalse(prompt.call_count < 1, 'Programmet måste be om input två gånger.')
            self.assertTrue(jeans_tshirt in output, f"Med input:\n{input}\nprogrammet förväntas skriva ut följande rad\n" + jeans_tshirt+ "\nditt programs utskrift är\n"+ output)
            self.assertFalse(jumper in output, f"Med input:\n{input}\nprogrammet förväntas INTE skriva ut följande rader" + jumper+ "\nditt programs utskrift är\n"+ output)
            self.assertFalse(jacket in output, f"Med input:\n{input}\nprogrammet förväntas INTE skriva ut följande rader" + jacket+ "\nditt programs utskrift är\n"+ output)
            self.assertFalse(warm_coat in output, f"Med input:\n{input}\nprogrammet förväntas INTE skriva ut följande rader" + warm_coat+ "\nditt programs utskrift är\n"+ output)
            self.assertFalse(gloves in output, f"Med input:\n{input}\nprogrammet förväntas INTE skriva ut följande rader\n" + gloves+ "\nditt programs utskrift är\n"+ output)
            self.assertFalse(umbrella in output, f"Med input:\n{input}\nprogrammet förväntas INTE skriva ut följande rader" + umbrella+ "\nditt programs utskrift är\n"+ output)
    
    def test_21_rain(self):
        with patch('builtins.input', side_effect = [ '21', 'ja', AssertionError("Inmatning frågas för många gånger.") ]) as prompt:
            reload_module(self.module)
            output = get_stdout()
            input = "21, ja"
            self.assertFalse(prompt.call_count < 1, 'Programmet måste be om input två gånger.')
            self.assertTrue(jeans_tshirt in output, f"Med input:\n{input}\nprogrammet förväntas skriva ut följande rad\n" + jeans_tshirt+ "\nditt programs utskrift är\n"+ output)
            self.assertFalse(jumper in output, f"Med input:\n{input}\nprogrammet förväntas INTE skriva ut följande rader" + jumper+ "\nditt programs utskrift är\n"+ output)
            self.assertFalse(jacket in output, f"Med input:\n{input}\nprogrammet förväntas INTE skriva ut följande rader" + jacket+ "\nditt programs utskrift är\n"+ output)
            self.assertFalse(warm_coat in output, f"Med input:\n{input}\nprogrammet förväntas INTE skriva ut följande rader" + warm_coat+ "\nditt programs utskrift är\n"+ output)
            self.assertFalse(gloves in output, f"Med input:\n{input}\nprogrammet förväntas INTE skriva ut följande rader" + gloves+ "\nditt programs utskrift är\n"+ output)
            self.assertTrue(umbrella in output, f"Med input:\n{input}\nprogrammet förväntas skriva ut följande rad\n" + umbrella+ "\nditt programs utskrift är\n"+ output)
    
    def test_15(self):
        with patch('builtins.input', side_effect = [ '15', 'nej', AssertionError("Inmatning frågas för många gånger.") ]) as prompt:
            reload_module(self.module)
            output = get_stdout()
            input = "15, nej"
            self.assertFalse(prompt.call_count < 1, 'Programmet måste be om input två gånger.')
            self.assertTrue(jeans_tshirt in output, f"Med input:\n{input}\nprogrammet förväntas skriva ut följande rad\n" + jeans_tshirt+ "\nditt programs utskrift är\n"+ output)
            self.assertTrue(jumper in output, f"Med input:\n{input}\nprogrammet förväntas skriva ut följande rad\n" + jumper+ "\nditt programs utskrift är\n"+ output)
            self.assertFalse(jacket in output, f"Med input:\n{input}\nprogrammet förväntas INTE skriva ut följande rader" + jacket+ "\nditt programs utskrift är\n"+ output)
            self.assertFalse(warm_coat in output, f"Med input:\n{input}\nprogrammet förväntas INTE skriva ut följande rader" + warm_coat+ "\nditt programs utskrift är\n"+ output)
            self.assertFalse(gloves in output, f"Med input:\n{input}\nprogrammet förväntas INTE skriva ut följande rader" + gloves+ "\nditt programs utskrift är\n"+ output)
            self.assertFalse(umbrella in output, f"Med input:\n{input}\nprogrammet förväntas INTE skriva ut följande rader" + umbrella+ "\nditt programs utskrift är\n"+ output)
    
    def test_20_rain(self):
        with patch('builtins.input', side_effect = [ '20', 'ja', AssertionError("Inmatning frågas för många gånger.") ]) as prompt:
            reload_module(self.module)
            output = get_stdout()
            input = "20, ja"
            self.assertFalse(prompt.call_count < 1, 'Programmet måste be om input två gånger.')
            self.assertTrue(jeans_tshirt in output, f"Med input:\n{input}\nprogrammet förväntas skriva ut följande rad\n" + jeans_tshirt+ "\nditt programs utskrift är\n"+ output)
            self.assertTrue(jumper in output, f"Med input:\n{input}\nprogrammet förväntas skriva ut följande rad\n" + jumper+ "\nditt programs utskrift är\n"+ output)
            self.assertFalse(jacket in output, f"Med input:\n{input}\nprogrammet förväntas INTE skriva ut följande rader" + jacket+ "\nditt programs utskrift är\n"+ output)
            self.assertFalse(warm_coat in output, f"Med input:\n{input}\nprogrammet förväntas INTE skriva ut följande rader" + warm_coat+ "\nditt programs utskrift är\n"+ output)
            self.assertFalse(gloves in output, f"Med input:\n{input}\nprogrammet förväntas INTE skriva ut följande rader" + gloves+ "\nditt programs utskrift är\n"+ output)
            self.assertTrue(umbrella in output, f"Med input:\n{input}\nprogrammet förväntas skriva ut följande rad\n" + umbrella+ "\nditt programs utskrift är\n"+ output)
    
    def test_10(self):
        with patch('builtins.input', side_effect = [ '10', 'nej', AssertionError("Inmatning frågas för många gånger.") ]) as prompt:
            reload_module(self.module)
            output = get_stdout()
            input = "10, nej"
            self.assertFalse(prompt.call_count < 1, 'Programmet måste be om input två gånger.')
            self.assertTrue(jeans_tshirt in output, f"Med input:\n{input}\nprogrammet förväntas skriva ut följande rad\n" + jeans_tshirt+ "\nditt programs utskrift är\n"+ output)
            self.assertTrue(jumper in output, f"Med input:\n{input}\nprogrammet förväntas skriva ut följande rad\n" + jumper+ "\nditt programs utskrift är\n"+ output)
            self.assertTrue(jacket in output, f"Med input:\n{input}\nprogrammet förväntas skriva ut följande rad\n" + jacket+ "\nditt programs utskrift är\n"+ output)
            self.assertFalse(warm_coat in output, f"Med input:\n{input}\nprogram is NOT expected to print out following row\n" + warm_coat+ "\nditt programs utskrift är\n"+ output)
            self.assertFalse(gloves in output, f"Med input:\n{input}\nprogram is NOT expected to print out following row\n" + gloves+ "\nditt programs utskrift är\n"+ output)
            self.assertFalse(umbrella in output, f"Med input:\n{input}\nprogram is NOT expected to print out following row\n" + umbrella+ "\nditt programs utskrift är\n"+ output)
    
    def test_3(self):
        with patch('builtins.input', side_effect = [ '3', 'nej', AssertionError("Inmatning frågas för många gånger.") ]) as prompt:
            reload_module(self.module)
            output = get_stdout()
            input = "3, nej"
            self.assertFalse(prompt.call_count < 1, 'Programmet måste be om input två gånger.')
            self.assertTrue(jeans_tshirt in output, f"Med input:\n{input}\nprogrammet förväntas skriva ut följande rad\n" + jeans_tshirt+ "\nditt programs utskrift är\n"+ output)
            self.assertTrue(jumper in output, f"Med input:\n{input}\nprogrammet förväntas skriva ut följande rad\n" + jumper+ "\nditt programs utskrift är\n"+ output)
            self.assertTrue(jacket in output, f"Med input:\n{input}\nprogrammet förväntas skriva ut följande rad\n" + jacket+ "\nditt programs utskrift är\n"+ output)
            self.assertTrue(warm_coat in output, f"Med input:\n{input}\nprogrammet förväntas skriva ut följande rad\n" + warm_coat+ "\nditt programs utskrift är\n"+ output)
            self.assertTrue(gloves in output, f"Med input:\n{input}\nprogrammet förväntas skriva ut följande rad\n" + gloves+ "\nditt programs utskrift är\n"+ output)
            self.assertFalse(umbrella in output, f"Med input:\n{input}\nprogram is NOT expected to print out following row\n" + umbrella+ "\nditt programs utskrift är\n"+ output)
    
    def test_5_rain(self):
        with patch('builtins.input', side_effect = [ '5', 'ja', AssertionError("Inmatning frågas för många gånger.") ]) as prompt:
            reload_module(self.module)
            output = get_stdout()
            input = "5, ja"
            self.assertFalse(prompt.call_count < 1, 'Programmet måste be om input två gånger.')
            self.assertTrue(jeans_tshirt in output, f"Med input:\n{input}\nprogrammet förväntas skriva ut följande rad\n" + jeans_tshirt+ "\nditt programs utskrift är\n"+ output)
            self.assertTrue(jumper in output, f"Med input:\n{input}\nprogrammet förväntas skriva ut följande rad\n" + jumper+ "\nditt programs utskrift är\n"+ output)
            self.assertTrue(jacket in output, f"Med input:\n{input}\nprogrammet förväntas skriva ut följande rad\n" + jacket+ "\nditt programs utskrift är\n"+ output)
            self.assertTrue(warm_coat in output, f"Med input:\n{input}\nprogrammet förväntas skriva ut följande rad\n" + warm_coat+ "\nditt programs utskrift är\n"+ output)
            self.assertTrue(gloves in output, f"Med input:\n{input}\nprogrammet förväntas skriva ut följande rad\n" + gloves+ "\nditt programs utskrift är\n"+ output)
            self.assertTrue(umbrella in output, f"Med input:\n{input}\nprogrammet förväntas skriva ut följande rad\n" + umbrella+ "\nditt programs utskrift är\n"+ output)
    

if __name__ == '__main__':
    unittest.main()
